/**
 */
package autosar40.swcomponent.datatype.dataprototypes.impl;

import autosar40.bswmodule.bswinterfaces.BswinterfacesPackage;

import autosar40.bswmodule.bswinterfaces.impl.BswinterfacesPackageImpl;

import autosar40.bswmodule.bswoverview.BswoverviewPackage;

import autosar40.bswmodule.bswoverview.impl.BswoverviewPackageImpl;

import autosar40.commonstructure.internalbehavior.InternalbehaviorPackage;
import autosar40.commonstructure.internalbehavior.impl.InternalbehaviorPackageImpl;
import autosar40.commonstructure.modedeclaration.ModedeclarationPackage;

import autosar40.commonstructure.modedeclaration.impl.ModedeclarationPackageImpl;

import autosar40.ecuresource.EcuresourcePackage;

import autosar40.ecuresource.impl.EcuresourcePackageImpl;

import autosar40.swcomponent.components.ComponentsPackage;

import autosar40.swcomponent.components.impl.ComponentsPackageImpl;

import autosar40.swcomponent.composition.CompositionPackage;

import autosar40.swcomponent.composition.impl.CompositionPackageImpl;

import autosar40.swcomponent.composition.instancerefs.InstancerefsPackage;
import autosar40.swcomponent.composition.instancerefs.impl.InstancerefsPackageImpl;
import autosar40.swcomponent.datatype.dataprototypes.DataprototypesFactory;
import autosar40.swcomponent.datatype.dataprototypes.DataprototypesPackage;
import autosar40.swcomponent.datatype.dataprototypes.VariableDataPrototype;

import autosar40.swcomponent.portinterface.PortinterfacePackage;

import autosar40.swcomponent.portinterface.impl.PortinterfacePackageImpl;

import autosar40.swcomponent.swcinternalbehavior.SwcinternalbehaviorPackage;

import autosar40.swcomponent.swcinternalbehavior.impl.SwcinternalbehaviorPackageImpl;

import autosar40.system.SystemPackage;

import autosar40.system.fibex.fibexcore.coretopology.CoretopologyPackage;
import autosar40.system.fibex.fibexcore.coretopology.impl.CoretopologyPackageImpl;
import autosar40.system.impl.SystemPackageImpl;

import autosar40.system.swmapping.SwmappingPackage;
import autosar40.system.swmapping.impl.SwmappingPackageImpl;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class DataprototypesPackageImpl extends EPackageImpl implements DataprototypesPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass variableDataPrototypeEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see autosar40.swcomponent.datatype.dataprototypes.DataprototypesPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private DataprototypesPackageImpl() {
		super(eNS_URI, DataprototypesFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link DataprototypesPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static DataprototypesPackage init() {
		if (isInited) return (DataprototypesPackage)EPackage.Registry.INSTANCE.getEPackage(DataprototypesPackage.eNS_URI);

		// Obtain or create and register package
		DataprototypesPackageImpl theDataprototypesPackage = (DataprototypesPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof DataprototypesPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new DataprototypesPackageImpl());

		isInited = true;

		// Obtain or create and register interdependencies
		EcuresourcePackageImpl theEcuresourcePackage = (EcuresourcePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(EcuresourcePackage.eNS_URI) instanceof EcuresourcePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(EcuresourcePackage.eNS_URI) : EcuresourcePackage.eINSTANCE);
		ModedeclarationPackageImpl theModedeclarationPackage = (ModedeclarationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ModedeclarationPackage.eNS_URI) instanceof ModedeclarationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ModedeclarationPackage.eNS_URI) : ModedeclarationPackage.eINSTANCE);
		InternalbehaviorPackageImpl theInternalbehaviorPackage = (InternalbehaviorPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(InternalbehaviorPackage.eNS_URI) instanceof InternalbehaviorPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(InternalbehaviorPackage.eNS_URI) : InternalbehaviorPackage.eINSTANCE);
		CompositionPackageImpl theCompositionPackage = (CompositionPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CompositionPackage.eNS_URI) instanceof CompositionPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CompositionPackage.eNS_URI) : CompositionPackage.eINSTANCE);
		InstancerefsPackageImpl theInstancerefsPackage = (InstancerefsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(InstancerefsPackage.eNS_URI) instanceof InstancerefsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(InstancerefsPackage.eNS_URI) : InstancerefsPackage.eINSTANCE);
		ComponentsPackageImpl theComponentsPackage = (ComponentsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ComponentsPackage.eNS_URI) instanceof ComponentsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ComponentsPackage.eNS_URI) : ComponentsPackage.eINSTANCE);
		PortinterfacePackageImpl thePortinterfacePackage = (PortinterfacePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PortinterfacePackage.eNS_URI) instanceof PortinterfacePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PortinterfacePackage.eNS_URI) : PortinterfacePackage.eINSTANCE);
		SwcinternalbehaviorPackageImpl theSwcinternalbehaviorPackage = (SwcinternalbehaviorPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SwcinternalbehaviorPackage.eNS_URI) instanceof SwcinternalbehaviorPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SwcinternalbehaviorPackage.eNS_URI) : SwcinternalbehaviorPackage.eINSTANCE);
		SystemPackageImpl theSystemPackage = (SystemPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SystemPackage.eNS_URI) instanceof SystemPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SystemPackage.eNS_URI) : SystemPackage.eINSTANCE);
		SwmappingPackageImpl theSwmappingPackage = (SwmappingPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SwmappingPackage.eNS_URI) instanceof SwmappingPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SwmappingPackage.eNS_URI) : SwmappingPackage.eINSTANCE);
		CoretopologyPackageImpl theCoretopologyPackage = (CoretopologyPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CoretopologyPackage.eNS_URI) instanceof CoretopologyPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CoretopologyPackage.eNS_URI) : CoretopologyPackage.eINSTANCE);
		BswoverviewPackageImpl theBswoverviewPackage = (BswoverviewPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(BswoverviewPackage.eNS_URI) instanceof BswoverviewPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(BswoverviewPackage.eNS_URI) : BswoverviewPackage.eINSTANCE);
		BswinterfacesPackageImpl theBswinterfacesPackage = (BswinterfacesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(BswinterfacesPackage.eNS_URI) instanceof BswinterfacesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(BswinterfacesPackage.eNS_URI) : BswinterfacesPackage.eINSTANCE);

		// Create package meta-data objects
		theDataprototypesPackage.createPackageContents();
		theEcuresourcePackage.createPackageContents();
		theModedeclarationPackage.createPackageContents();
		theInternalbehaviorPackage.createPackageContents();
		theCompositionPackage.createPackageContents();
		theInstancerefsPackage.createPackageContents();
		theComponentsPackage.createPackageContents();
		thePortinterfacePackage.createPackageContents();
		theSwcinternalbehaviorPackage.createPackageContents();
		theSystemPackage.createPackageContents();
		theSwmappingPackage.createPackageContents();
		theCoretopologyPackage.createPackageContents();
		theBswoverviewPackage.createPackageContents();
		theBswinterfacesPackage.createPackageContents();

		// Initialize created meta-data
		theDataprototypesPackage.initializePackageContents();
		theEcuresourcePackage.initializePackageContents();
		theModedeclarationPackage.initializePackageContents();
		theInternalbehaviorPackage.initializePackageContents();
		theCompositionPackage.initializePackageContents();
		theInstancerefsPackage.initializePackageContents();
		theComponentsPackage.initializePackageContents();
		thePortinterfacePackage.initializePackageContents();
		theSwcinternalbehaviorPackage.initializePackageContents();
		theSystemPackage.initializePackageContents();
		theSwmappingPackage.initializePackageContents();
		theCoretopologyPackage.initializePackageContents();
		theBswoverviewPackage.initializePackageContents();
		theBswinterfacesPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theDataprototypesPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(DataprototypesPackage.eNS_URI, theDataprototypesPackage);
		return theDataprototypesPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getVariableDataPrototype() {
		return variableDataPrototypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataprototypesFactory getDataprototypesFactory() {
		return (DataprototypesFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		variableDataPrototypeEClass = createEClass(VARIABLE_DATA_PROTOTYPE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes

		// Initialize classes, features, and operations; add parameters
		initEClass(variableDataPrototypeEClass, VariableDataPrototype.class, "VariableDataPrototype", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		// Create resource
		createResource(eNS_URI);
	}

} //DataprototypesPackageImpl
