package org.safe.metamodelgen.templates.internal.util;

import org.eclipse.eatop.metamodelgen.templates.internal.util.GenModels;
import org.eclipse.emf.codegen.ecore.genmodel.GenModel;
import org.safe.metamodelgen.templates.source.SAFESourceRevisions;

///////////SAFE specific
public class SAFEGenModels extends GenModels{

	   public static boolean IsLibJarCreated(GenModel genModel) {
			return false;
		}
	    
	    public static boolean IsLibSrcZipCreated(GenModel genModel) {
			return false;
		}
	
	    public static String getSAFEReleaseNamespace(GenModel genModel) {
			String nsURI = GenModels.getRootGenPackage(genModel).getNSURI();
			return nsURI; //nsURI.substring(0, nsURI.lastIndexOf("/")); //$NON-NLS-1$ 
		}
	    
	    public static boolean hasRootUtilitiesGenPackage(GenModel genModel) {
	    	return false;
	    }

	    public static String getFileExtension(GenModel genModel){	
	    	return "safe";
	    }

	    /**
	     * Returns true if we have an SAFE meta-model
	     */
	    public static boolean isSAFEMetaModel(GenModel genModel) {
	    	return true;
	    }	

	    public static String getNamespacePattern(GenModel genModel){
	    	return "http://safe-project.eu/"+ SAFESourceRevisions.get().major + "\\.[0-9]\\.[0-9]+$";
	    }

	    /**
	     * creates the "filter" attribute for the extension point
	     * "org.eclipse.sphinx.emf.validation.registration"
	     */
	    public static String createValidationFilter(GenModel genModel) {
	    	return "_" + SAFESourceRevisions.get().major + SAFESourceRevisions.get().minor;			
	    }	

	    /**
	     * creates the "Name" attribute for the extension point
	     * "org.eclipse.sphinx.emf.validation.registration"
	     */
	    public static String createValidationName(GenModel genModel) {
	    	return "SAFE " + SAFESourceRevisions.get().major + SAFESourceRevisions.get().minor;			
	    }

}
